local assets=
{
	Asset("ANIM", "anim/swap_changmao.zip"),
	Asset("ANIM", "anim/changmao.zip"),
    	Asset("ATLAS", "images/inventoryimages/changmao.xml"),
    	Asset("IMAGE", "images/inventoryimages/changmao.tex"),
}




local max_upgrades = TUNING.XIMICHANGMAO_LV






local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_changmao", "swap_changmao")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
	owner.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")	
end


local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end


local function applyupgrades(inst)
    --20等级上限 = 46
    inst.level = math.min(inst.level, max_upgrades)
	local dmg = TUNING.XIMICHANGMAO_DAMAGE + inst.level/2 
	inst.components.weapon:SetDamage(dmg)
	if inst.level >= max_upgrades then
	inst.components.weapon:SetRange(1.8,1.8)
	inst.components.equippable.walkspeedmult = 1.1
	inst.components.equippable.dapperness = TUNING.DAPPERNESS_LARGE
	end
	inst.damage = dmg
end


local function onsave(inst, data)
    data.level = inst.level > 0 and inst.level or nil
end

local function onpreload(inst, data)
    if data ~= nil and data.level ~= nil then
      inst.level = data.level
      applyupgrades(inst)
   end
end


local function OnGetItemFromPlayer(inst, giver, item)
    if item.prefab == "ximibi" then
		inst.level = inst.level + 1
		applyupgrades(inst)
	if inst.level >= max_upgrades then
		giver.components.talker:Say("等级已经满了")
	else
		local dmg = TUNING.XIMICHANGMAO_DAMAGE + inst.level/2 
		giver.components.talker:Say("等级 : "..inst.level.." 伤害 ："..dmg)
	end	
	end
	
end


local function OnRefuseItem(inst, giver, item)
	if item.prefab ~= "ximibi" then
		giver.components.talker:Say("请给予花瓣升级")
	else
		if inst.level >= max_upgrades then
		giver.components.talker:Say("等级已经满了")
		end
	end
end

local function AcceptTest(inst, item)
    return item.prefab == "ximibi" and inst.level < max_upgrades
end




local function onattack(inst, attacker, target)

local mhp = target.components.health.maxhealth

	if attacker.components.health.currenthealth == attacker.components.health.maxhealth then
	--target.components.health:DoDelta(-10)
	target.components.combat:GetAttacked(attacker, mhp * 0.01)
	
--[[	elseif attacker.components.health.currenthealth < attacker.components.health.maxhealth  and attacker.components.health.currenthealth > attacker.components.health.maxhealth * 0.75 then
	--target.components.health:DoDelta(-20)
	target.components.combat:GetAttacked(attacker, 20)
	
	
	elseif attacker.components.health.currenthealth <= attacker.components.health.maxhealth * 0.75 and attacker.components.health.currenthealth > attacker.components.health.maxhealth * 0.5 then
	--target.components.health:DoDelta(-30)
	target.components.combat:GetAttacked(attacker, 30)
	
	
	elseif attacker.components.health.currenthealth <= attacker.components.health.maxhealth * 0.5 and attacker.components.health.currenthealth > attacker.components.health.maxhealth * 0.25 then 
	--target.components.health:DoDelta(-40)
	target.components.combat:GetAttacked(attacker, 40)
	
	
	elseif attacker.components.health.currenthealth <= attacker.components.health.maxhealth * 0.25 then
	--target.components.health:DoDelta(-50)
	target.components.combat:GetAttacked(attacker, 50)]]
	
	end
	

end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local netw = inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("changmao")
    inst.AnimState:SetBuild("changmao")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddTag("sharp")

    if not TheWorld.ismastersim then
        return inst
    end

    inst.entity:SetPristine()
	
	inst:AddComponent("talker")
    inst.components.talker.fontsize = 28
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(.9, .4, .4)
    inst.components.talker.offset = Vector3(0, 0, 0)
    inst.components.talker.symbol = "swap_object"
	
    inst:AddComponent("weapon")
	inst.level = 0
	inst.damage = inst.components.weapon.damage
	applyupgrades(inst)
    inst.components.weapon:SetOnAttack(onattack)
	
	
	inst:AddComponent("named")
	inst.components.named:SetName("玫瑰长矛\n1个西米翅膀增加1等级、0.5攻击\n每次攻击附加目标最大生命1%伤害")
	

    inst:AddComponent("inspectable")
	
	inst:AddComponent("trader")
    inst.components.trader:SetAcceptTest(AcceptTest)
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader.onrefuse = OnRefuseItem
    
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/changmao.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	if max_upgrades == 99999999 then
	inst.components.weapon:SetRange(1.8,1.8)
	inst.components.equippable.walkspeedmult = 1.1
	inst.components.equippable.dapperness = TUNING.DAPPERNESS_LARGE
    end
	
	
	inst.OnSave = onsave
    inst.OnPreLoad = onpreload
    
    return inst
end


return Prefab( "common/inventory/changmao", fn, assets, prefabs) 
