local assets=
{
	Asset("ANIM", "anim/swap_changmaokt.zip"),
	Asset("ANIM", "anim/changmaokt.zip"),
    	Asset("ATLAS", "images/inventoryimages/changmaokt.xml"),
    	Asset("IMAGE", "images/inventoryimages/changmaokt.tex"),
}


local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_changmaokt", "swap_changmaokt")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end


local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end


local function onhit(inst, attacker, target)
    local impactfx = SpawnPrefab("impact")
    if impactfx ~= nil then
        local follower = impactfx.entity:AddFollower()
        follower:FollowSymbol(target.GUID, target.components.combat.hiteffectsymbol, 0, 0, 0)
        if attacker ~= nil then
            impactfx:FacePoint(attacker.Transform:GetWorldPosition())
        end
    end
   inst:Remove()
end


--local function onattack(weapon, attacker, target)
--end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local netw = inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("changmaokt")
    inst.AnimState:SetBuild("changmaokt")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddTag("sharp")

    if not TheWorld.ismastersim then
        return inst
    end

    inst.entity:SetPristine()

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(TUNING.XIMICHANGMAOKT_DAMAGE)
--    inst.components.weapon:SetOnAttack(onattack)
	inst.components.weapon:SetRange(10,12)
    

	inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(60)
    inst.components.projectile:SetOnHitFn(onhit)
--    inst:ListenForEvent("onthrown", onthrown)
	

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/changmaokt.xml"
	
	inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	inst.components.equippable.equipstack = true
    
    return inst
end


return Prefab( "common/inventory/changmaokt", fn, assets, prefabs) 
