local assets=
{
	Asset("ANIM", "anim/king.zip"),
	Asset("ANIM", "anim/swap_king.zip"),
    	Asset("ATLAS", "images/inventoryimages/king.xml"),
    	Asset("IMAGE", "images/inventoryimages/king.tex"),
}



local max_upgrades = TUNING.KING_LV



local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_king", "swap_king")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
	owner.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
--	if inst.level and inst.damage  then
--		if inst.level >= max_upgrades then
--			inst.components.talker:Say("满级 : "..inst.level.." 伤害 ： "..inst.damage)
--		else
--			inst.components.talker:Say("等级 : "..inst.level.." 伤害 ： "..inst.damage)
--		end
		

--	end

end



local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end



local function applyupgrades(inst)
    --20等级上限 = TUNING.KING_LV
    inst.level = math.min(inst.level, max_upgrades)
	local dmg = TUNING.KING_DAMAGE + inst.level 
	inst.components.weapon:SetDamage(dmg)
	if inst.level >= max_upgrades then
	inst.components.equippable.walkspeedmult = 1.05
	inst.components.equippable.dapperness = TUNING.DAPPERNESS_LARGE/2
    end 
	inst.damage = dmg
--	if inst.level >= max_upgrades then
--		inst.components.talker:Say("等级已经满了")
--	else
--		inst.components.talker:Say("等级 : "..inst.level.." 伤害 ："..dmg)
--	end
	
end


local function onsave(inst, data)
    data.level = inst.level > 0 and inst.level or nil
end

local function onpreload(inst, data)
    if data ~= nil and data.level ~= nil then
      inst.level = data.level
      applyupgrades(inst)
   end
end

local function OnGetItemFromPlayer(inst, giver, item)
    if item.prefab == "ximibi" then
		inst.level = inst.level + 1
		applyupgrades(inst)
	if inst.level >= max_upgrades then
		giver.components.talker:Say("等级已经满了")
	else
		local dmg = TUNING.KING_DAMAGE + inst.level
		giver.components.talker:Say("等级 : "..inst.level.." 伤害 ："..dmg)
	end	
	end
	
end

local function OnRefuseItem(inst, giver, item)
	if item.prefab ~= "ximibi" then
		giver.components.talker:Say("请给予翅膀升级")
--		inst.components.talker:Say("请给予翅膀升级")
	else
		if inst.level >= max_upgrades then
		giver.components.talker:Say("等级已经满了")
--		inst.components.talker:Say("等级已经满了")
		end
	end
end

local function AcceptTest(inst, item)
    return item.prefab == "ximibi" and inst.level < max_upgrades
end





local function onattack( inst, attacker, target )

  if target.components.health.currenthealth <= target.components.health.maxhealth * 0.05 then
	-- target.components.health:DoDelta(-100000)	
	 target.components.combat:GetAttacked(attacker, 10000, inst)
	 inst.components.talker:Say("斩杀！")
  end
end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local netw = inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("king")
    inst.AnimState:SetBuild("king")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddTag("sharp")

	inst:AddComponent("talker")
    inst.components.talker.fontsize = 28
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(.9, .4, .4)
    inst.components.talker.offset = Vector3(0, 0, 0)
    inst.components.talker.symbol = "swap_object"	
	
	
    inst.entity:SetPristine()	
	
    if not TheWorld.ismastersim then
        return inst
    end


	
    inst:AddComponent("weapon")
	inst.level = 0
	inst.damage = inst.components.weapon.damage
	applyupgrades(inst)
    inst.components.weapon:SetOnAttack(onattack)
    

	inst:AddComponent("named")
	inst.components.named:SetName("无双剑\n剑刃十分锋利\n斩杀生命低于5%的一切生物\n1个西米翅膀增加等级1、攻击1")
	

    inst:AddComponent("inspectable")
	
	inst:AddComponent("trader")
    inst.components.trader:SetAcceptTest(AcceptTest)
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader.onrefuse = OnRefuseItem
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/king.xml"
	inst.components.inventoryitem.keepondeath = true
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    if max_upgrades == 99999999 then
	inst.components.equippable.walkspeedmult = 1.05
	inst.components.equippable.dapperness = TUNING.DAPPERNESS_LARGE/2
    end
	
	
	inst.OnSave = onsave
    inst.OnPreLoad = onpreload
    
    return inst
end


return Prefab( "common/inventory/king", fn, assets, prefabs) 
