local assets=
{
	Asset("ANIM", "anim/swap_redsword.zip"),
	Asset("ANIM", "anim/redsword.zip"),
    	Asset("ATLAS", "images/inventoryimages/redsword.xml"),
    	Asset("IMAGE", "images/inventoryimages/redsword.tex"),
}



local max_upgrades = TUNING.REDSWORD_LV


local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_redsword", "swap_redsword")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end


local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end


local function applyupgrades(inst)
    --20等级上限 = TUNING.KING_LV
    inst.level = math.min(inst.level, max_upgrades)
	local dmg = TUNING.REDSWORD_DAMAGE + inst.level 
	inst.components.weapon:SetDamage(dmg)
	inst.damage = dmg
--	if inst.level >= max_upgrades then
--		inst.components.talker:Say("等级已经满了")
--	else
--		inst.components.talker:Say("等级 : "..inst.level.." 伤害 ："..dmg)
--	end
	
end


local function JX(inst)

	local redsword_jx = SpawnPrefab("redsword_jx")
	local container = inst.components.inventoryitem:GetContainer()
	if container ~= nil then
		local slot = inst.components.inventoryitem:GetSlotNum()
		inst:Remove()
		container:GiveItem(redsword_jx, slot)
	else
		local x, y, z = inst.Transform:GetWorldPosition()
		inst:Remove()
		redsword_jx.Transform:SetPosition(x, y, z)
	end

end




local function onsave(inst, data)
    data.level = inst.level > 0 and inst.level or nil
end

local function onpreload(inst, data)
    if data ~= nil and data.level ~= nil then
      inst.level = data.level
      applyupgrades(inst)
   end
end




local function onattack( inst, owner, target )
	if owner.components.health and owner.components.health:GetPercent() < 1 and not target:HasTag("wall") then
        owner.components.health:DoDelta(1,false,"batbat")
    end
	

	if inst.level >= max_upgrades then	
	owner.components.talker:Say("龙吟之力，觉醒！")
	owner.SoundEmitter:PlaySound("dontstarve/rain/thunder_close")
	JX(inst)
	
	else
	
	--EPIC怪物经验
	if target.components.health:IsDead() and target:HasTag("epic") then
	inst.level = inst.level + 5
	applyupgrades(inst)
	local dmg = TUNING.REDSWORD_DAMAGE + inst.level
	owner.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	inst.components.talker:Say("等级+5".."  龙吟更重了".."\n等级 : "..inst.level.." 伤害 ："..dmg)
	
	
	--影怪
	elseif  target.components.health:IsDead() and target:HasTag("nightmarecreature") then
	inst.level = inst.level + 0.5
	applyupgrades(inst)
	local dmg = TUNING.REDSWORD_DAMAGE + inst.level
	owner.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	inst.components.talker:Say("等级+0.5".."  虚无".."\n等级 : "..inst.level.." 伤害 ："..dmg)
	
	
	--蠕虫
	elseif target.components.health:IsDead() and target:HasTag("worm") then
	inst.level = inst.level + 0.5
	applyupgrades(inst)
	local dmg = TUNING.REDSWORD_DAMAGE + inst.level
	owner.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	inst.components.talker:Say("等级+0.5".."  地龙".."\n等级 : "..inst.level.." 伤害 ："..dmg)
	
	
	--暗影三基佬
	elseif target.components.health:IsDead() and target:HasTag("shadowchesspiece") then
	inst.level = inst.level + 1
	applyupgrades(inst)
	local dmg = TUNING.REDSWORD_DAMAGE + inst.level
	owner.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	inst.components.talker:Say("等级+1".."  邪恶".."\n等级 : "..inst.level.." 伤害 ："..dmg)
	
	
	--大型生物
	elseif target.components.health:IsDead() and target:HasTag("largecreature") then
	inst.level = inst.level + 0.5
	applyupgrades(inst)
	local dmg = TUNING.REDSWORD_DAMAGE + inst.level
	owner.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	inst.components.talker:Say("等级+0.5".."  大型怪物".."\n等级 : "..inst.level.." 伤害 ："..dmg)
	
	
	--怪物
	elseif target.components.health:IsDead() and target:HasTag("monster") then
	inst.level = inst.level + 0.1
	applyupgrades(inst)
	local dmg = TUNING.REDSWORD_DAMAGE + inst.level
	owner.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	inst.components.talker:Say("等级+0.1".."  更多的鲜血".."\n等级 : "..inst.level.." 伤害 ："..dmg)
	end
	

end	
	
end





local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local netw = inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("redsword")
    inst.AnimState:SetBuild("redsword")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddTag("sharp")



	inst:AddComponent("talker")
    inst.components.talker.fontsize = 28
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(.9, .4, .4)
    inst.components.talker.offset = Vector3(0, 0, 0)
    inst.components.talker.symbol = "swap_object"
	

	
	inst.entity:SetPristine()
	
    if not TheWorld.ismastersim then
        return inst
    end

    

    inst:AddComponent("weapon")
	inst.level = 0
	inst.damage = inst.components.weapon.damage
	applyupgrades(inst)
    inst.components.weapon:SetOnAttack(onattack)

	inst:AddComponent("named")
	inst.components.named:SetName("红龙剑\n渴望鲜血的剑\n击杀怪物升级\n满级释放龙魂")

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/redsword.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )

	
	
	inst.OnSave = onsave
    inst.OnPreLoad = onpreload
    
    return inst
end


return Prefab( "common/inventory/redsword", fn, assets, prefabs) 
