local assets=
{
	Asset("ANIM", "anim/swap_redsword_jx.zip"),
	Asset("ANIM", "anim/redsword_jx.zip"),
    	Asset("ATLAS", "images/inventoryimages/redsword_jx.xml"),
    	Asset("IMAGE", "images/inventoryimages/redsword_jx.tex"),
}



local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_redsword_jx", "swap_redsword_jx")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end


local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end



local function ownerhp(inst, attacker, target, skipsanity, owner)
	if inst.components.inventoryitem.owner ~= nil then
		local value = math.ceil(3)
		local time = 3
		local owner = inst.components.inventoryitem.owner
		for i = 1, math.ceil(2) do
			inst:DoTaskInTime(time*i, function()
				if owner and owner.components.health and owner.components.health.currenthealth < owner.components.health.maxhealth and owner.components.health.currenthealth > 0 then
					owner.components.health:DoDelta(value)
				end
			end)
		end
	end
end



local function onattack(inst, attacker, target, skipsanity, owner)
 --[[   if owner.components.health and owner.components.health:GetPercent() < 1 and not target:HasTag("wall") then
       owner.components.health:DoDelta(TUNING.BATBAT_DRAIN,false,"batbat")
    end]]
	ownerhp(inst, attacker, target, skipsanity, owner)
end


local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local netw = inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("redsword_jx")
    inst.AnimState:SetBuild("redsword_jx")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddTag("sharp")


	
	inst.entity:SetPristine()
	
    if not TheWorld.ismastersim then
        return inst
    end

    

	
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(TUNING.REDSWORD_DAMAGE+TUNING.REDSWORD_LV+15)
    inst.components.weapon:SetOnAttack(onattack)
    
	inst:AddComponent("named")
	inst.components.named:SetName("龙魂·觉醒\n充斥鲜血的剑\n完全释放力量")

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/redsword_jx.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	inst.components.equippable.dapperness = -TUNING.DAPPERNESS_LARGE
	inst.components.equippable.walkspeedmult = 1.05
	
	
    return inst
end


return Prefab( "common/inventory/redsword_jx", fn, assets, prefabs) 
