local assets=
{
	Asset("ANIM", "anim/swap_wand.zip"),
	Asset("ANIM", "anim/wand.zip"),
    	Asset("ATLAS", "images/inventoryimages/wand.xml"),
    	Asset("IMAGE", "images/inventoryimages/wand.tex"),
}




local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_wand", "wand")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end


local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end



local function onattack(inst, owner, target)
local hp = target.components.health.currenthealth
owner.components.health:DoDelta(hp*0.02)
end


local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local netw = inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("wand")
    inst.AnimState:SetBuild("wand")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddTag("sharp")
	inst:AddTag("shadow")
	
	inst.entity:SetPristine()
	
    if not TheWorld.ismastersim then
        return inst
    end



    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(100)
    inst.components.weapon:SetOnAttack(onattack)
    
	inst:AddComponent("named")
	inst.components.named:SetName("萨拉迈尼\n瓦里安·乌瑞恩佩剑\n此剑赋予真正的勇士\n缅怀我们一起走过的艰难岁月\n攻击附带目标当前生命2%吸血")



    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/wand.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	inst.components.equippable.walkspeedmult = 1.1
	inst.components.equippable.dapperness = TUNING.DAPPERNESS_LARGE * 4
    
    return inst
end


return Prefab( "common/inventory/wand", fn, assets, prefabs) 
