local assets=
{
	Asset("ANIM", "anim/swap_xiangrikui.zip"),
	Asset("ANIM", "anim/xiangrikui.zip"),
    	Asset("ATLAS", "images/inventoryimages/xiangrikui.xml"),
    	Asset("IMAGE", "images/inventoryimages/xiangrikui.tex"),
}

prefabs = {
	"xiangrikui",
}


local function xiangrikuilightfn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddLight()
    inst.entity:AddNetwork()

    inst:AddTag("FX")

    inst.Light:SetIntensity(TUNING.XIANGRIKUI_QD)
    inst.Light:SetRadius(TUNING.XIANGRIKUI_FW)
    inst.Light:Enable(true)
    inst.Light:SetFalloff(1)
    inst.Light:SetColour(200/255, 100/255, 170/255)

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false

    return inst
end

local function lighton(inst, owner)
    if inst._light == nil or not inst._light:IsValid() then
        inst._light = SpawnPrefab("xiangrikuilight")
    end
    if owner ~= nil then
        inst._light.entity:SetParent(owner.entity)
    end
end


local function lightoff(inst)
    if inst._light ~= nil then
            if inst._light:IsValid() then
                inst._light:Remove()
            end
            inst._light = nil
        end
end











local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_xiangrikui", "swap_xiangrikui")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
	
	lighton(inst, owner)
end


local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
	
	lightoff(inst, owner)
end



local function onattack(inst, owner, target)
    if owner.components.health and owner.components.health:GetPercent() < 1 and not target:HasTag("wall") then
        owner.components.health:DoDelta(1,false,"batbat")
    end
	if target.components.freezable ~= nil then
        target.components.freezable:AddColdness(TUNING.XIANGRIKUI_PA)
        target.components.freezable:SpawnShatterFX()
    end
end


local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local netw = inst.entity:AddNetwork()
	
	inst.entity:AddLight()

    MakeInventoryPhysics(inst)
	
	inst.Light:SetIntensity(TUNING.XIANGRIKUI_QD)
    inst.Light:SetRadius(TUNING.XIANGRIKUI_FW)
    inst.Light:Enable(true)
    inst.Light:SetFalloff(1)
    inst.Light:SetColour(200/255, 100/255, 170/255)	
    
    inst.AnimState:SetBank("xiangrikui")
    inst.AnimState:SetBuild("xiangrikui")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddTag("sharp")

    if not TheWorld.ismastersim then
        return inst
    end

    inst.entity:SetPristine()

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(TUNING.XIANGRIKUI_DAMAGE)
	inst.components.weapon:SetRange(TUNING.XIANGRIKUI_RANG,TUNING.XIANGRIKUI_RANG)
    inst.components.weapon:SetOnAttack(onattack)
    

    inst:AddComponent("inspectable")
	
	
	inst:AddComponent("tool")
	if TUNING.XIANGRIKUI_CHOP then
	inst.components.tool:SetAction(ACTIONS.CHOP) --可砍树
	end
	
	if TUNING.XIANGRIKUI_MINE then
	inst.components.tool:SetAction(ACTIONS.MINE) --可挖矿
	end
	
	if TUNING.XIANGRIKUI_DIG then
	inst.components.tool:SetAction(ACTIONS.DIG) --可铲子
	end
	
	if TUNING.XIANGRIKUI_NET then
	inst.components.tool:SetAction(ACTIONS.NET) --可网兜
	end
	
	if TUNING.XIANGRIKUI_HAMMER then
	inst.components.tool:SetAction(ACTIONS.HAMMER) --可锤子
	end
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/xiangrikui.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	inst.components.equippable.walkspeedmult = TUNING.XIANGRIKUI_SPEED
	inst.components.equippable.dapperness = TUNING.DAPPERNESS_LARGE
    
    return inst
end


return Prefab( "common/inventory/xiangrikui", fn, assets, prefabs),
	   Prefab("xiangrikuilight", xiangrikuilightfn)
