local assets=
{
	Asset("ANIM", "anim/swap_ximigj.zip"),
	Asset("ANIM", "anim/ximigj.zip"),
    	Asset("ATLAS", "images/inventoryimages/ximigj.xml"),
    	Asset("IMAGE", "images/inventoryimages/ximigj.tex"),
}



local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_ximigj", "swap_ximigj")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end


local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end


local function onattack(weapon, attacker, target)
    if attacker and attacker.components.hunger then
		attacker.components.hunger:DoDelta(-2)
		attacker.components.health:DoDelta(-1)
    end
end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local netw = inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("ximigj")
    inst.AnimState:SetBuild("ximigj")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddTag("shadow")

	inst.entity:SetPristine()
	
    if not TheWorld.ismastersim then
        return inst
    end



    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(TUNING.XIMIGJ_DAMAGE)
    inst.components.weapon:SetOnAttack(onattack)
	inst.components.weapon:SetRange(11, 13)
	inst.components.weapon:SetProjectile("ximigj_projectile")
    


    inst:AddComponent("inspectable")
	
	inst:AddComponent("named")
	inst.components.named:SetName("西米白羽弓\n每次攻击消耗2点饥饿1点血量")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/ximigj.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	inst.components.equippable.walkspeedmult = 1.25
    
    return inst
end


return Prefab( "common/inventory/ximigj", fn, assets, prefabs) 
