local assets=
{
	Asset("ANIM", "anim/swap_ximijita.zip"),
	Asset("ANIM", "anim/ximijita.zip"),
    	Asset("ATLAS", "images/inventoryimages/ximijita.xml"),
    	Asset("IMAGE", "images/inventoryimages/ximijita.tex"),
}




local dmg = TUNING.XIMIJITA_DAMAGE


local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_ximijita", "swap_ximijita")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end


local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end




local function onattack(inst, attacker, target)

local hp = target.components.health.currenthealth
local mhp = target.components.health.maxhealth

	if hp <= mhp and hp > mhp * 0.9 then
	target.components.combat:GetAttacked(attacker, dmg*0.1)
	
	elseif hp <= mhp * 0.9 and hp > mhp * 0.8 then
	target.components.combat:GetAttacked(attacker, dmg*0.2)

	
	elseif hp <= mhp * 0.8 and hp > mhp * 0.7 then
	target.components.combat:GetAttacked(attacker, dmg*0.3)

	
	elseif hp <= mhp * 0.7 and hp > mhp * 0.6 then
	target.components.combat:GetAttacked(attacker, dmg*0.4)

	
	elseif hp <= mhp * 0.6 and hp > mhp * 0.5 then
	--target.components.health:DoDelta(-dmg*0.5)
	target.components.combat:GetAttacked(attacker, dmg*0.5)

	
	elseif hp <= mhp * 0.5 and hp > mhp * 0.4 then
	target.components.combat:GetAttacked(attacker, dmg*0.6)

	
	elseif hp <= mhp * 0.4 and hp > mhp * 0.3 then
	target.components.combat:GetAttacked(attacker, dmg*0.7)

	
	elseif hp <= mhp * 0.3 and hp > mhp * 0.2 then
	target.components.combat:GetAttacked(attacker, dmg*0.8)

	
	elseif hp <= mhp * 0.2 and hp > mhp * 0.1 then
	target.components.combat:GetAttacked(attacker, dmg*0.9)

	
	elseif hp <= mhp * 0.1 and hp > 0 then
	target.components.combat:GetAttacked(attacker, dmg)

	end

	
end


local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local netw = inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("ximijita")
    inst.AnimState:SetBuild("ximijita")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddTag("sharp")

	    inst.entity:SetPristine()

	
	
    if not TheWorld.ismastersim then
        return inst
    end


    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(dmg)
    inst.components.weapon:SetOnAttack(onattack)
    
	inst:AddComponent("named")
	inst.components.named:SetName("吉他巨斧\n破釜沉舟绝不回头\n目标生命值越低，攻击越高")
	
	inst:AddComponent("tool")
	inst.components.tool:SetAction(ACTIONS.CHOP,8) --可砍树
	


    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/ximijita.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	inst.components.equippable.dapperness = TUNING.DAPPERNESS_LARGE * 2
	inst.components.equippable.walkspeedmult = 1.05
    
    return inst
end


return Prefab( "common/inventory/ximijita", fn, assets, prefabs) 
