local assets=
{
	Asset("ANIM", "anim/swap_ximisz.zip"),
	Asset("ANIM", "anim/ximisz.zip"),
    	Asset("ATLAS", "images/inventoryimages/ximisz.xml"),
    	Asset("IMAGE", "images/inventoryimages/ximisz.tex"),
}



local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_ximisz", "swap_ximisz")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end


local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end


local function onattack(weapon, attacker, target)
    if attacker and attacker.components.hunger then
		attacker.components.hunger:DoDelta(-2)
		attacker.components.health:DoDelta(-1)
    end
end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local netw = inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("ximisz")
    inst.AnimState:SetBuild("ximisz")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddTag("shadow")

	inst.entity:SetPristine()
	
    if not TheWorld.ismastersim then
        return inst
    end



    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(TUNING.XIMISZ_DAMAGE)
    inst.components.weapon:SetOnAttack(onattack)
	inst.components.weapon:SetRange(10, 12)
	inst.components.weapon:SetProjectile("ximisz_projectile")
    


    inst:AddComponent("inspectable")
	
	inst:AddComponent("named")
	inst.components.named:SetName("西米离火扇\n每次攻击消耗2点饥饿1点血量")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/ximisz.xml"
	
    inst:AddComponent("insulator")
    inst.components.insulator:SetInsulation(TUNING.INSULATION_LARGE)
	inst.components.insulator:SetSummer()
	
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	inst.components.equippable.walkspeedmult = 1.1
    
    return inst
end


return Prefab( "common/inventory/ximisz", fn, assets, prefabs) 
